// 아이디어
// 완전탐색 문제가 아니다.
// 수학적으로 접근해서, 오름차순 정렬 후
// 작은것부터 채우다, 예산보다 커지면, 그전까지 넣었던 만큼의 갯수만 제출하면 된다.
// 예를 들어,
// 작은걸로 2개까지 되다가, 작은걸로 3개가 안된다는 것은
// 어떤 수를 쓰든 3개는 안된다는 것이기에, 2개가 맥시멈이다.
// 문제 자체가 제한이 많다.
// 값이 딱 맞아 떨어지는 것, 최대한 많이 넣으라는 것
// 이 두가지 때문에, 오름차순으로 배치 후
// 작은 값부터 넣으면서 해야되고, 넘는 순간 넣은 것의 갯수만 세야한다.
// 예산이 크다고 해서, 큰 것부터 넣으면, 최소로 지원이 될 수 도 있다.
// 2, 2, 4, 5, 7  으로 가정하면, 예산이 9 면
// 경계는 4까지이고 모자른 상태에서 5를 넣으면 넘어선다.
// 그래서 갯수는 4가 아닌 3이된다.
// 경계에 있는 4와 5을 교환해서 결과적으로 해결된다.
// 예산이 올라가면, 똑같이 경계선만 상승해서, 앞뒤로 바꾸면 해결된다.
// 문제 자체가 그렇게 구성이 되어있다.

// 그래서 이 문제의 핵심은 오름차순과 경계선과의 관계이다.

function solution(d, budget) {
  d = d.sort((a, b) => a - b);
  let sum = 0;
  let i = 0;
  for (i = 0; i < d.length; ++i) {
    sum += d[i];
    if (sum == budget) return i + 1;
    if (sum > budget) return i;
  }
  return d.length;
}

function solution(d, budget) {
  let sum = 0;
  let ans = 0;
  d.sort((a, b) => a - b).forEach((v) => {
    sum += v;
    if (sum <= budget) ++ans;
  });
  return ans;
}
